using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;

namespace HuntingSuccubus {
	public class HSHighHeel : MVRScript {
DAZCharacterSelector selector;
DAZClothingItem item;
bool heelloaded = false;
int retryAttempts;
		public override void Init() {
			try {
								SuperController.LogMessage("HighHeel Helper Starting");	
			selector = containingAtom.GetComponentInChildren<DAZCharacterSelector>();
			item = selector
    .clothingItems
    .First(h => h.displayName == "Harli Heels");
								//SuperController.LogMessage("Cloth Heel Stop// Type="+item.GetType());	
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
					selector.SetActiveClothingItem(item, true);
					Scan();

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		
		void OnEnabledontwork() {
			try {
				// put code in here
					selector.SetActiveClothingItem(item, true);
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		
		void OnDisable() {
			try {
					selector.SetActiveClothingItem(item, false);
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		
		void Scan() {
					try {
										var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
				        foreach (var wrap in allWraps) 
						{
								//SuperController.LogMessage("WRAPCLOTH="+wrap.ToString());
								if (wrap.ToString().Contains("HarliHeels")||wrap.ToString().Contains("HarliHeels")) 
										{
										//SuperController.LogMessage("Heel Clothes Loaded="+wrap.ToString());	
										heelloaded = true;
										wrap.additionalThicknessMultiplier = 0.0001f;
										wrap.surfaceOffset = -0.05f;
										//continue;
											foreach (var mat in wrap.GPUmaterials) 
											{
											//SuperController.LogMessage("GPUmat name="+mat.name+", _AlphaAdjust="+mat.GetFloat("_AlphaAdjust"));
											mat.SetFloat("_AlphaAdjust", -1f);
											}
										}
						}
						
					foreach (Material mat in FindObjectsOfType(typeof(Material))) 
					{
						if(mat.ToString().Contains("Heel-1"))
						{					
						//SuperController.LogMessage("Heel Stick Clothes Material Loaded="+mat.name);
						mat.SetFloat("_AlphaAdjust", -1f);
						}	
					}
				if(!heelloaded)
					StartCoroutine(QueueRescan());
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}	
			
			
		}
		        protected IEnumerator Rescan()
        {
									//SuperController.LogMessage("Rescan");
            // wait for components to be destroyed
            yield return new WaitForEndOfFrame();
            Scan();
        }
		
		        private IEnumerator QueueRescan()
        {
			//SuperController.LogMessage("QueueRescaning-Return ReScan");
            // 1s normally or 40s during load
            if (retryAttempts < 20000) {
                //yield return new WaitForSeconds(0.2f);
				//SuperController.LogMessage("3-QueueResReAttempt:"+retryAttempts);
                retryAttempts++;
                yield return Rescan();
            }

        }

		void Update() {

		}

		void FixedUpdate() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void OnDestroy() {
				selector.SetActiveClothingItem(item, false);
		}

	}
}